import V from '../common/tool';
import C from '../io/config';
import {
    Pool
} from '../collection/pool';
import M from 'mysql';
import M2 from 'mssql';
import Mem from 'memcached';
import Mon from 'mongodb';
import N from '../net/tool';
import Q from 'querystring';
import Mail from 'emailjs';
import es from 'elasticsearch';
import Redis from 'ioredis';
import S from 'soap';
//import nosql from './nosql';
/**
 * //依托Middler框架完成对数据类型文件的处理，包括mysql mongodb sqlserver memcache ObjectDB(即自定义function) WebSocket等等数据源类型的操作
	//实现对如下格式文件的处理
		Ni:{
			ajaxtest2:{command:'http://localhost/VESHTest/Module/help/test.tjsonp?_n=recorder',dbtype:'tjson',params:{limit:11},template:'template1'},
			ajaxtest1:{command:'http://localhost/KDAPI/Module/GetOrderTrackItems.tjsonp?_n=Order',dbtype:'tjson',params:{},template:'template1'},
			'ajaxtest1.Cache':{command:function(res,params){return res[params.cacheKey];不写即使用默认值},dbtype:'json',params:{},template:'template2'},
			'ajaxtest1.Set':{command:function(res,params){res[params.cacheKey] = params.cacheValue;不写即使用默认值},dbtype:'json',params:{timeout1:{interval:'s',number:50}},template:'template2'},
			sqlinsert:{command:'create table if not exists table1(name Text,message text,time integer);insert into table1 values(?,?,?);',dbtype:'json',params:{data:[]},template:'sqltemp'},
			sqlselect:{command:'select * from table1;',dbtype:'json',params:{data:[]},template:'sqltemp'},
			sqlselect2:{command:'select * from table1 where name=?',dbtype:'json',params:{data:[]},template:'sqltemp'},		
			Name1:{command:'',params:{},dbtype:'json/tjson',template:'仅在Middler中调用NiMultiTemplateDecorator时启用'},
			wstest1: { command: 'abc.json', dbtype: 'json', params: {}, template: 'ws' },
			wstest2: { command: 'bcd.json?_n=MT, dbtype: 'json', params: {}, template: 'ws' }
		}
let t = middler.getObjectByAppName('Ni','templatename');
let res = t.excute('aaa.GetProductDetail',{ProductID:111},function(result){
	let res = result.last();
});
middler.setObjectByAppName('Ni','templatename',t);
//分离NiDataConfig完成Ni格式文件处理
//分离NiDataConfigConvert完成对Ni格式转成Config
//用于处理 Ni文件定义
*/
export const NiDataConfig = class extends C.Config {
    constructor() {
        super();
        const that = this;
        const {
            _,
            __
        } = pri(that, {
            mergeValue: param => {
                switch (param.type) {
                    case 'Int':
                    case 'int':
                    case 'int32':
                    case 'int16':
                    case 'int64':
                        param.value = param.value ? parseInt(param.value) : 0;
                        break;
                    case 'DateTime':
                    case 'Date':
                    case 'datetime':
                        param.value = param.value ? (param.value.split ? Date.parse(param.value) : new Date(param.value)) : new Date(0);
                        break;
                    case 'float':
                    case 'single':
                    case 'double':
                        param.value = param.value ? parseFloat(param.value) : 0;
                        break;
                    case 'string':
                    case 'String':
                        param.value = param.value == null ? null : (param.value + '');
                        break;
                }
            }
        });
    }
    standard(val) {
        let ret = {};
        for (let k in val) {
            let v = val[k] || {
                value: val[k],
                isStandard: true
            };
            ret[k] = v.isStandard ? v : (v.type || (v.out && v.out != '')) ? (function () {
                v.isStandard = true;
                return v;
            })() : {
                value: v,
                isStandard: true
            };
        }
        return ret;
    }
    merge(...vals) {
        const {
            _,
            __
        } = pri(this);
        //默认设置最后一个参数为值，其它参数为标准化数据 key:{value:val,type:'',out:false,isStandard:true}
        vals = V.merge.apply(null, vals.map(v => _.standard(v)));
        for (let k in vals)
            __.mergeValue(vals[k]);
        return vals;
    }
    getValue(...args) {
        const {
            _,
            __
        } = pri(this);
        const ret = super.getValue.apply(_, args); //这里借用VJ的方法将ni.js中定义的V.merge方法改为参数标准化方法
        if (ret) {
            ret.merge = ret.merge || function (...args2) {
                return _.merge.apply(_, args2);
            }
        }
        return ret;
    }
};
export const NiDataConfigConvert = class extends C.ConfigConvert {
    constructor() {
        super();
        pri(this);
    }
    toConfig(val) {
        const ret = new NiDataConfig();
        if (val) {
            if (typeof (val) == 'object') {
                for (let k in val) {
                    let v = val[k];
                    if (v) ret.data[k.toLowerCase()] = V.merge({
                        params: {}
                    }, v);
                }
            }
        }
        return ret;
    }
}
export const NiTemplate = class {
    constructor(res, cm) {
        const that = this;
        this.transaction = false;
        const {
            _,
            __
        } = pri(that, {
            lstCmd: [],
            KEY: ('Ni'),
            result: new NiDataResult(),
            res,
            cm,
            addCommand: (name, params) => {
                const {
                    _,
                    __
                } = pri(that);
                const cmd = __.cm.getConfigValue(__.KEY, name.toLowerCase());
                let command = name;
                let template = "";
                if (cmd) {
                    command = cmd.command;
                    params = cmd.merge(cmd.params, V.getValue(params, {}));
                    template = cmd.template;
                }
                __.lstCmd[__.lstCmd.length] = ({
                    name: command,
                    params: params,
                    template: template,
                    key: name,
                    jsonp: (cmd && cmd.jsonp) ? cmd.jsonp : false,
                    dbtype: (cmd && cmd.dbtype) ? cmd.dbtype : "tjson"
                });
            },
            excute: async() => {
                const {
                    _,
                    __
                } = pri(that);
                let _cms = __.lstCmd;
                __.lstCmd = [];
                if (_cms.length > 0) {
                    let conn = await __.res.getDBConnection();
                    try {
                        if (_cms.length > 1) conn.transaction = true;
                        let cmd = __.res.getDBCommand();
                        cmd.connection = conn;
                        //执行过程存在严重漏洞 考虑 直接执行与非直接执行的异同
                        await V.each(_cms, async v => {
                            cmd.command = v.name;
                            cmd.params = v.params;
                            cmd.dbtype = v.dbtype;
                            cmd.jsonp = v.jsonp;
                            //需要知晓connection的执行原理
                            if (conn.transaction) {
                                cmd.excute();
                            } else {
                                const data = await cmd.excute();
                                __.result.add((!data || (V.isArray(data) && data.length == 0)) ? false : data, v.key);
                            }
                            return false;
                        }, true);
                        if (conn.transaction && conn.commit)
                            await conn.commit();
                        return true;
                    } catch (err) {
                        V.showException('commit ', err);
                        throw err;
                    } finally {
                        __.res.backDBConnection(conn);
                    }
                } else {
                    V.showException('不能调用空的命令对象!');
                }
            }
        });
    }
    async excute(name, params = {}) {
        const {
            _,
            __
        } = pri(this);
        //__.addCommand(name, V.json(V.toJsonString(params)));
        //__.addCommand(name, V.merge({},params));
        __.addCommand(name, params);
        if (!_.transaction) {
            await __.excute();
        }
        return __.result;
    }
    async commit() {
        const {
            _,
            __
        } = pri(this);
        await __.excute();
        return __.result;
    }
    dispose() {
        const {
            _,
            __
        } = pri();
        for (let i in __) {
            //if (__[i].dispose) try { __[i].dispose() } catch (e) {}
            delete __[i];
        }
    }
    getCommand(name = '') {
        const {
            __
        } = pri(this);
        return V.merge({}, __.cm.getConfigValue(__.KEY, name.toLowerCase()) || {});
    }
};
export const NiTemplateManager = class {
    constructor(middler, appName = 'Ni') {
        pri(this, {
            middler: middler,
            KEY: appName
        });
    }
    async excute(tempName, name, params, func) {
        const {
            _,
            __
        } = pri(this);
        let temp = __.middler.getObjectByAppName(__.KEY, tempName);
        if (temp) {
            let result = await temp.excute(name, params);
            __.middler.setObjectByAppName(__.KEY, tempName, temp);
            return result;
        } else {
            throw new Error('没有找到Template:' + tempName);
        }
    }
    dispose() {
        const {
            __
        } = pri(this);
        for (let i in __) delete __.i;
    }
    getCommand(tempName = '', name = '') {
        const {
            _,
            __
        } = pri(this);
        let temp = __.middler.getObjectByAppName(__.KEY, tempName);
        if (temp) {
            let result = temp.getCommand(name);
            __.middler.setObjectByAppName(__.KEY, tempName, temp);
            return result;
        } else {
            throw new Error('没有找到Template:' + tempName);
        }
    }
};
export const NiDataResult = class {
    constructor() {
        const {
            __
        } = pri(this, {
            data: {},
            kv: {},
            datas: [],
            hasData: function (data) {
                let ret = false;
                if (V.isArray(data)) {
                    for (let i = 0; i < data.length; i++) {
                        if (data[i] && __.hasData(data[i])) return true;
                    }
                } else {
                    for (let i in data)
                        if (data[i]) return true;
                }
                return false;
            }
        });
    }
    get(key) {
        const {
            _,
            __
        } = pri(this);
        return __.data[key] || (__.kv[key] ? __.kv[key][1] : null);
    }
    add(data, name) {
        const {
            _,
            __
        } = pri(this);
        if (data && !__.kv[name]) {
            __.data[__.datas.length] = data;
            __.kv[name] = [__.datas.length, data];
            __.datas[__.datas.length] = data;
        } else if (__.kv[name]) {
            const id = __.kv[name][0];
            __.data[id] = data;
            __.kv[name] = [__.datas.length, data];
            __.datas[id] = data;
        }
    }
    last() {
        const {
            _,
            __
        } = pri(this);
        return _.get(__.datas.length - 1);
    }
    /**
     * 一般用于处理单个对象
     */
    single() {
        const {
            _,
            __
        } = pri(this);
        return (_.hasData()) ? (function () {
            const data = _.get(__.datas.length - 1);
            return (data[0] && data[0][0]) ? data[0][0] : {};
        })() : null;
    }
    each(key, func) {
        const {
            _,
            __
        } = pri(this);
        let val = _.get(key);
        if (val && V.isArray(val)) {
            return V.each(val, func);
        } else throw new Error('遍历对象不存在或者不是数组')
    }
    clear() {
        const {
            _,
            __
        } = pri(this);
        __.data = {};
        __.kv = {};
        __.datas = [];
    }
    hasData(key) {
        const {
            _,
            __
        } = pri(this);
        return __.hasData(key ? get(key) : __.datas);
    }
};
/**
 * getDBConnection 异步
 */
export const NiDataResource = class {
    constructor(factory, params = {}) {
        const {
            _,
            __
        } = pri(this, {
            fac: factory,
            params: params
        });
    }
    async getDBConnection() {
        const {
            _,
            __
        } = pri(this);
        const conn = __.fac.createDBConnection();
        conn.params = V.merge(conn.params, __.params);
        if (!conn.isOpen) {
            //open需要转同步
            await conn.open();
        }
        return conn;
    }
    backDBConnection(conn) {
        const {
            _,
            __
        } = pri(this);
        __.fac.backDBConnection(conn);
    }
    getDBCommand() {
        const {
            _,
            __
        } = pri(this);
        return __.fac.createDBCommand();
    }
};
export const NiInstanceDataResource = class extends NiDataResource {
    constructor(factory, params = {}) {
        super(factory, params);
    }
    getDBConnection() {
        return super.getDBConnection();
    }
    backDBConnection(conn) {
        super.backDBConnection(conn);
    }
    getDBCommand() {
        return super.getDBCommand();
    }
};
export const NiStaticDataResource = class extends NiDataResource {
    constructor(factory, params = {}) {
        super(factory, params);
        pri(this, {
            conn: null
        });
    }
    async getDBConnection() {
        const {
            _,
            __
        } = pri(this);
        if (!__.conn || !__.conn.isOpen)
            __.conn = await super.getDBConnection();
        return __.conn;
    }
    backDBConnection(conn) {
        const {
            _,
            __
        } = pri(this);
        if (conn != __.conn && conn.isOpen)
            super.backDBConnection(conn);
    }
    getDBCommand() {
        return super.getDBCommand();
    }
};
export const NiPoolDataResource = class extends NiDataResource {
    constructor(factory, params = {}, size = 50) {
        super(factory, params);
        pri(this, {
            pool: new Pool(size, async() => {
                let conn = await super.getDBConnection();
                if (!conn.dispose)
                    conn.dispose = conn.close;
                return conn;
            })
        });
    }
    async getDBConnection() {
        const {
            _,
            __
        } = pri(this);
        return await __.pool.getValue();
    }
    backDBConnection(conn) {
        const {
            _,
            __
        } = pri(this);
        __.pool.setValue(conn);
    }
};
export const NiDataFactory = class {
    constructor() {
        pri(this);
    }
    createDBConnection() {
        return new NiDataConnection();
    }
    createDBCommand() {
        return new NiDataCommand();
    }
    async backDBConnection(conn) {
        if (conn.isOpen) {
            await conn.close();
        }
    }
}
/**
 * Connection 全部是callback
 */
export const NiDataConnection = class {
    constructor() {
        pri(this);
        this.isOpen = false;
        this.transaction = false;
        this.params = {};
    }
    async open() {
        const {
            _,
            __
        } = pri(this);
        _.isOpen = true;
    }
    async close() {
        const {
            _,
            __
        } = pri(this);
        _.isOpen = false;
    }
    async invoke(cmd) {
        return [];
    }
    async commit() {
        return [];
    }
};
/**
 * DBCommand 命令使用callback命令
 */
export const NiDataCommand = class {
    constructor() {
        const {
            _,
            __
        } = pri(this);
        _.connection = null;
        _.command = '';
        _.params = {
            dbtype: 'json'
        };
    }
    async excute() {
        const {
            _,
            __
        } = pri(this);
        if (!_.connection || !_.connection.isOpen) {
            V.showException('数据库未连接');
            throw new Error('数据库未连接');
        } else {
            try {
                //此句关键
                return await _.connection.invoke(_);
            } catch (e) {
                V.showException('connection invoke success方法', e);
                throw e;
            }
        }
    }
};
export const NiTemplateDecorator = class extends NiTemplate {
    constructor(res, cacheres, cm, params = {}) {
        super(res, cm);
        const that = this;
        const {
            _,
            __
        } = pri(that, {
            KEY: 'Ni',
            lstCmd2: {},
            params,
            cacheres,
            setCommand: (res, params) => {
                const {
                    _,
                    __
                } = pri(that);
                params = V.merge(__.params, params);
                res[params.cacheKey] = V.toJsonString({
                    data: params.cacheValue,
                    date: (params.timeout ? new Date().add(params.timeout.interval, params.timeout.number).getTime() : false)
                });
                return null;
            },
            clearCommand: function (res, params) {
                if (res.removeItem) {
                    res.removeItem(params.cacheKey, null);
                } else if (res[params.cacheKey]) {
                    delete res[params.cacheKey];
                }
                return null;
            },
            cacheCommand: function (res, params) {
                let val = null;
                /*if(res.getItem){
                	val = V.json(res.getItem(params.cacheKey));
                } else {*/
                if (res[params.cacheKey]) {
                    val = V.json(res[params.cacheKey]);
                }
                //}						
                if (val) {
                    if (val.date) {
                        if (parseFloat(val.date) < new Date().getTime()) {
                            delete res[params.cacheKey];
                            return null;
                        }
                    }
                    return val.data;
                } else return null;
            }
        });
        const _addCommand = __.addCommand;
        const _excute = __.excute;
        __.addCommand = (name, params) => {
            const {
                _,
                __
            } = pri(that);
            let index = __.lstCmd.length;
            _addCommand.apply(_, [name, params]);
            if (__.lstCmd.length != index) {
                let command = null;
                let cmd = __.cm.getConfigValue(__.KEY, name.toLowerCase() + '.cache');
                if (!cmd) {
                    cmd = __.cm.getConfigValue(__.KEY, name.toLowerCase() + '.clear');
                    if (cmd) {
                        command = cmd.command || __.clearCommand;
                    }
                } else {
                    command = cmd.command || __.cacheCommand;
                }
                if (cmd) {
                    __.lstCmd2[index] = {
                        name: command,
                        key: name,
                        params: cmd.merge(__.lstCmd[__.lstCmd.length - 1].params, {
                            cacheKey: V.hash(name + '.Set.' + V.toJsonString(__.lstCmd[__.lstCmd.length - 1].params))
                        })
                    }
                }
            }
        };
        __.excute = async() => {
            const {
                _,
                __
            } = pri(that);
            let _cms = __.lstCmd;
            __.lstCmd = [];
            if (_cms.length > 0) {
                let conn = await __.res.getDBConnection();
                try {
                    if (_cms.length > 1) conn.transaction = true;
                    let cmd = __.res.getDBCommand();
                    cmd.connection = conn;
                    //执行过程存在严重漏洞 考虑 直接执行与非直接执行的异同
                    let i = 0;
                    await V.each(_cms, async v => {
                        const _nicmd = __.lstCmd2[i++];
                        if (_nicmd) {
                            const _conn = await __.cacheres.getDBConnection();
                            try {
                                const _cmd = __.cacheres.getDBCommand();
                                _cmd.conn = _conn;
                                _cmd.command = _nicmd.name;
                                _cmd.params = V.merge(_nicmd.params, v.params);
                                _cmd.dbtype = v.dbtype;
                                _cmd.jsonp = v.jsonp;
                                const data = await _cmd.excute();
                                if (data) {
                                    __.result.add((!data || (V.isArray(data) && data.length == 0)) ? false : data, v.key);
                                    return false;
                                }
                            } finally {
                                __.cachers.backDBConnection(_conn);
                            }
                        }
                        cmd.command = v.name;
                        cmd.params = v.params;
                        cmd.dbtype = v.dbtype;
                        cmd.jsonp = v.jsonp;
                        //需要知晓connection的执行原理
                        if (conn.transaction) {
                            cmd.excute();
                        } else {
                            let data = await cmd.excute();
                            __.result.add((!data || (V.isArray(data) && data.length == 0)) ? false : data, v.key);
                            if (data && data.length > 0 && !(data.length == 1 && data[0].length == 0)) {
                                //新增缓存
                                let _nicmd = __.cm.getConfigValue(__.KEY, v.key.toLowerCase() + '.set');
                                if (_nicmd) {
                                    const _conn = await __.cacheres.getDBConnection();
                                    try {
                                        const _cmd = __.cacheres.getDBCommand();
                                        _cmd.connection = _conn;
                                        _cmd.command = _nicmd.command || __.setCommand;
                                        _cmd.params = _nicmd.merge(_nicmd.params, cmd.params, {
                                            cacheKey: V.hash(v.key + '.Set.' + V.toJsonString(cmd.params)),
                                            cacheValue: data
                                        });
                                        cmd.dbtype = v.dbtype;
                                        cmd.jsonp = v.jsonp;
                                        const _data = await _cmd.excute();
                                    } finally {
                                        __.cacheres.backDBConnection(_conn);
                                    }
                                }
                            }
                        }
                        return false;
                    }, true);
                    if (conn.transaction && conn.commit)
                        await conn.commit();
                    return __.result;
                } catch (err) {
                    V.showException('commit ', err);
                } finally {
                    __.res.backDBConnection(conn);
                }
            } else {
                V.showException('不能调用空的命令对象!');
            }
        };
    }
};
export const NiMultiTemplateDecorator = class extends NiTemplate {
    constructor(res, cm, relcm, appName = "Ni") {
        super(res, cm);
        const that = this;
        const {
            _,
            __
        } = pri(that, {
            KEY: appName,
            ni: new NiTemplateManager(relcm, appName),
            lstCmd2: {}
        });
        const _addCommand = __.addCommand;
        const _excute = __.excute; //todo 可能可以实现覆盖!
        __.addCommand = (name, params) => {
            const {
                _,
                __
            } = pri(that);
            let index = __.lstCmd.length;
            _addCommand.apply(_, [name, params]);
            let cmd = __.lstCmd[__.lstCmd.length - 1];
            if (cmd.template) {
                //调用templdate优先 复用其次
                __.lstCmd2[__.lstCmd.length - 1] = true;
            }
        };
        __.excute = async() => {
            const {
                _,
                __
            } = pri(that);
            let _cms = __.lstCmd,
                _cm2 = __.lstCmd2;
            __.lstCmd = [], __.lstCmd2 = {};
            if (_.transaction)
                throw new Error('NiMultiTemplateDecorator不支持事务，容易发生内容错位');
            if (_cms.length > 0) {
                let i = 0;
                await V.each(_cms, async v => {
                    let _nicmd = _cm2[i++];
                    if (_nicmd) {
                        const result = await __.ni.excute(v.template, v.key, v.params);
                        __.result.add((result && result.get(v.key)) ? result.get(v.key) : [], v.key);
                    } else {
                        const conn = await __.res.getDBConnection();
                        try {
                            let cmd = __.res.getDBCommand();
                            cmd.connection = conn;
                            cmd.command = v.name;
                            cmd.params = v.params;
                            cmd.dbtype = v.dbtype;
                            cmd.jsonp = v.jsonp;
                            const data = await cmd.excute();
                            __.result.add((typeof (data) == 'undefined' || (V.isArray(data) && data.length == 0)) ? false : data, v.key);
                        } finally {
                            __.res.backDBConnection(conn);
                        }
                    }
                    return false;
                }, true);
            } else {
                V.showException('不能调用空的命令对象!');
            }
            return __.result;
        }
    }
    dispose() {
        const {
            __
        } = pri(this);
        __.ni.dispose();
        super.dispose();
    }
};
/**
 * MySQL 池连接方式工厂
 */
export const NiMySQLDataFactory = class extends NiDataFactory {
    constructor() {
        super();
        const that = this;
        that.idic = {};
        const {
            _,
            __
        } = pri(that, {
            MySQLConnection: class extends NiDataConnection {
                constructor() {
                    super();
                    const that = this;
                    const {
                        _,
                        __
                    } = pri(this, {
                        cmds: [],
                        conn: null,
                        getValue: p => p.value,
                        toList: vals => {
                            const {
                                _,
                                __
                            } = pri(that);
                            if (vals[0]) {
                                let ret = [];
                                for (let i = 0; i < vals.length; i++)
                                    ret[ret.length] = (__.toList(vals[i]));
                                return ret;
                            } else return (function () {
                                const ret = {};
                                for (let k in vals) {
                                    switch (V.getType(vals[k])) {
                                        case 'Date':
                                        case 'number':
                                        case 'boolean':
                                        case 'string':
                                        case 'null':
                                            ret[k] = vals[k];
                                            break;
                                    }
                                }
                                return ret;
                            })();
                        },
                        invoke: async(command, params) => {
                            try {
                                const {
                                    _,
                                    __
                                } = pri(that);

                                let result = await V.callback(__.conn.query, __.conn, _.prepare(command, params));

                                let data = [];
                                if (!result[0]) result = [
                                    []
                                ];
                                //过滤mysql自定义的更新结果JSON
                                result = result.filter(v => v.serverStatus == undefined);

                                //过滤mysql上复制:=
                                result = result.filter(v => {
                                    switch (V.getType(v)) {
                                        case 'object':
                                        case 'Object':
                                            for (var k in v) {
                                                if (k.indexOf(':=') >= 0) return false;
                                            }
                                            break;
                                        case 'Array':
                                            const _v = v.filter(r => {
                                                for (var k2 in r) {
                                                    if (k2.indexOf(':=') >= 0) return false;
                                                }
                                                return true;
                                            });
                                            return _v.length > 0 || v.length == 0;
                                    }
                                    return true;
                                });
                                if (!result[0]) result = [
                                    []
                                ];
                                if (V.getType(result[0]).toLowerCase() != 'array') result = [result];
                                //自动补充mysql在单sql下不是2个嵌套数据的问题
                                if (result && result.length > 0)
                                    for (let i = 0; i < result.length; i++) {
                                        if (typeof (result[i]) != 'undefined' && result[i].length > 0)
                                            data[data.length] = (__.toList(result[i]));
                                        else if (typeof (result[i]) != 'undefined' && !V.isArray(result[i])) { //if (typeof(result[i].affectedRows) == 'undefined') {
                                            data[data.length] = __.toList([result[i]]);
                                        } else {
                                            data[data.length] = [];
                                        }
                                    }
                                else data[data.length] = [];
                                return data;
                            } catch (e) {
                                console.log(e.message);
                                throw e;
                            }
                        }
                    });
                    _.params = {
                        multipleStatements: true,
                        connectionLimit: 10
                    };
                }
                prepare(cmd, paras) {
                    const {
                        _,
                        __
                    } = pri(this);
                    //需要将{}转成[] 处理
                    if (cmd && paras) {
                        let vals = [];
                        cmd = cmd.replace(/\?[a-zA-Z0-9_]+/g, (data) => {
                            vals[vals.length] = __.getValue(paras[data.trim('?')]);
                            return '?';
                        });
                        return {
                            sql: cmd,
                            values: vals,
                            timeout: _.params.timeout || 60000 //1分钟
                        };
                    } else
                        throw new Error('prepare方法要求写入command参数与paras参数');
                }
                async invoke(cmd) {
                    //需要处理单条与多条s
                    const {
                        _,
                        __
                    } = pri(this);
                    if (_.transaction) {
                        __.cmds[__.cmds.length] = {
                            command: cmd.command,
                            params: cmd.params
                        };
                    } else
                        return await __.invoke(cmd.command, cmd.params);
                }
                async commit() {
                    const {
                        _,
                        __
                    } = pri(this);
                    if (_.transaction) {
                        //事务性处理
                        try {
                            await V.callback(__.conn.beginTransaction, __.conn);
                            let data = [];
                            let cmds = __.cmds;
                            __.cmds = [];
                            await V.each(cmds, async v => {
                                //console.log(v.cmd.params);
                                data[data.length] = await __.invoke(v.command, v.params);
                                return false;
                            }, true);
                            await V.callback(__.conn.commit, __.conn);
                            return data;
                        } catch (e) {
                            await V.callback(__.conn.rollback, __.conn);
                            throw e;
                        }
                    } else
                        throw new Error('非事务条件下不可调用此方法');
                }
                async open() {
                    const {
                        _,
                        __
                    } = pri(this);
                    const key = V.hash2(V.toJsonString(_.params));
                    that.idic[key] = that.idic[key] || M.createPool(_.params);

                    var getonconn = async function () {
                        var conn = await V.callback(that.idic[key].getConnection, that.idic[key]);
                        if (!!!conn._ison) {
                            conn._ison = true
                            conn.on('error', async function (err) {
                                if (err.code == 'PROTOCOL_CONNECTION_LOST' ||
                                    err.code == 'PROTOCOL_ENQUEUE_AFTER_FATAL_ERROR') {
                                    try {
                                        conn.close();
                                    } catch (e) {}
                                    __.conn = await getonconn();
                                }
                            })
                        }

                        return conn;
                    };
                    __.conn = await getonconn();

                    await super.open();
                }
                async close() {
                    const {
                        _,
                        __
                    } = pri(this);
                    try {
                        if (__.conn && __.conn.release)
                            __.conn.release();
                        else if (__.conn && __.conn.end)
                            __.conn.end();
                        else if (__.conn && __.conn.dispose)
                            __.conn.dispose();
                    } catch (e) {}
                    __.cmds = [];
                    __.conn = null;
                    await super.close();
                }
            }
        });
    }
    createDBConnection() {
        const {
            _,
            __
        } = pri(this);
        return new __.MySQLConnection();
    }
    dispose() {
        for (let i in this.idic) {
            if (this.idic[i] && this.idic[i].dispose) {
                const v = this.idic[i];
                V.tryC(() => {
                    v.dispose();
                })
            }
        }
    }
};
/*
默认类型转换
String -> sql.NVarChar
Number -> sql.Int
Boolean -> sql.Bit
Date -> sql.DateTime
Buffer -> sql.VarBinary
sql.Table -> sql.TVP
 */
export const NiMsSQLDataFactory = class extends NiDataFactory {
    constructor() {
        super();
        const that = this;
        that.idic = {};
        const {
            _,
            __
        } = pri(that, {
            MsSQLConnection: class extends NiDataConnection {
                constructor() {
                    super();
                    const that = this;
                    const {
                        _,
                        __
                    } = pri(this, {
                        cmds: [],
                        conn: null,
                        invoke: async(source, command, params) => {
                            const {
                                _,
                                __
                            } = pri(that);
                            const request = new M2.Request(source);
                            request.multiple = true;
                            for (let i in params) {
                                //ni params 应该有 name:{type:'',value:''} or name:string ni定义未必支持
                                const type = M2[V.getValue(params[i].type, 'VarChar')] || M2.VarChar;
                                if (params[i].out)
                                    request.output(i, (params[i].length || 0) > 0 ? type(params[i].length) : type, params[i].value);
                                else
                                    request.input(i, (params[i].length || 0) > 0 ? type(params[i].length) : type, params[i].value);
                            }
                            let [result, affected] = [null, 0];
                            //await V.callback(request.prepare, request, command);
                            try {
                                [result, affected] = await V.callback(call => {
                                    if (command.indexOf(' ') >= 0)
                                        request.query(command, (err, result) => call(err, [result, err ? 0 : result.rowsAffected]));
                                    else
                                        request.execute(command, (err, result) => call(err, [result, err ? 0 : result.rowsAffected]));
                                });
                            } catch (e) {
                                console.log(e.message);
                                throw e;
                            }
                            //await V.callback(request.unprepare, request);
                            let data = [];
                            if (result.recordsets && result.recordsets.length > 0)
                                for (let i = 0; i < result.recordsets.length; i++) {
                                    if (result.recordsets[i] && result.recordsets[i].length > 0)
                                        data[data.length] = (result.recordsets[i]);
                                    else data[data.length] = (affected[i]) ? [{
                                        affected: affected[i]
                                    }] : [];
                                }
                            else data[data.length] = (affected && affected[0]) ? [{
                                affected: affected[0]
                            }] : [];
                            return data;
                        }
                    });
                    _.params = {
                        connectionLimit: 10,
                        timeout: 60000
                    };
                }
                async invoke(cmd) {
                    const {
                        _,
                        __
                    } = pri(this);
                    if (_.transaction) {
                        __.cmds[__.cmds.length] = {
                            command: cmd.command,
                            params: cmd.params
                        };
                    } else
                        return await __.invoke(__.conn, cmd.command, cmd.params);
                }
                async commit() {
                    const {
                        _,
                        __
                    } = pri(this);
                    if (_.transaction) {
                        //事务性处理
                        let trans = new M2.Transaction(__.conn);
                        try {
                            await V.callback(trans.begin, trans);
                            let data = [];
                            let cmds = __.cmds;
                            __.cmds = [];
                            await V.each(cmds, async v => {
                                data[data.length] = await __.invoke(trans, v.command, v.params);
                                return false;
                            }, true);
                            await V.callback(trans.commit, trans);
                            return data;
                        } catch (e) {
                            await V.callback(trans.rollback, trans);
                            throw e;
                        }
                    } else
                        throw new Error('非事务条件下不可调用此方法');
                }
                async open() {
                    const {
                        _,
                        __
                    } = pri(this);
                    const key = V.hash2(V.toJsonString(_.params));
                    const func = function () {
                        const conn = new M2.ConnectionPool(_.params);
                        conn.on('error', function (err) {
                            console.log('GCL mssql error:' + err.stack);
                            __.conn = func();
                        });
                        return conn;
                    }
                    __.conn = func();
                    await V.callback(__.conn.connect, __.conn);
                    await super.open();
                }
                async close() {
                    const {
                        _,
                        __
                    } = pri(this);
                    try {
                        if (__.conn && __.conn.close)
                            __.conn.close();
                        else if (__.conn && __.conn.end)
                            __.conn.end();
                        else if (__.conn && __.conn.dispose)
                            __.conn.dispose();
                    } catch (e) {} finally {
                        //const key = V.hash2(V.toJsonString(_.params));
                        //delete that.idic[key];
                    }
                    __.cmds = [];
                    __.conn = null;
                    await super.close();
                }
            }
        });
    }
    createDBConnection() {
        const {
            _,
            __
        } = pri(this);
        return new __.MsSQLConnection();
    }
    dispose() {
        for (let i in this.idic) {
            if (this.idic[i] && this.idic[i].close) {
                const v = this.idic[i];
                V.tryC(() => {
                    v.close();
                })
                delete this.idic[i];
            }
        }
    }
};
/**
 * 分离NiDBFactory产生NiDBConnection(Invoke) mysql,sqlserver,memcache,mongo websocket ObjectDB等各种资源
 */
export const NiObjectDataFactory = class extends NiDataFactory {
    constructor(middler = null) {
        super();
        if (!V.isValid(middler)) throw new Error('参数的定义必须要输入middler参数');
        const that = this;
        const {
            _,
            __
        } = pri(that, {
            middler: middler,
            ObjectConnection: class extends NiDataConnection {
                constructor() {
                    super();
                    const {
                        _,
                        __
                    } = pri(this, {
                        cmds: [],
                        invoke: async(command, params) => {
                            if (typeof (__.obj[command]) == 'function') {
                                let paras = [];
                                for (let k in params) {
                                    let v = params[k];
                                    paras[paras.length] = v.value;
                                };
                                return Reflect.apply(__.obj[command], __.obj, paras) || true;
                            } else throw new Error(command + '方法没有在对象源上找到');
                        }
                    });
                    _.params = {
                        app: 'Ni',
                        name: ''
                    };
                }
                async open() {
                    const {
                        _,
                        __
                    } = pri(this);
                    if (V.isValid(_.params.name)) {
                        //证明可用
                        __.obj = middler.getObjectByAppName(_.params.app, _.params.name);
                        if (!__.obj) throw new Error(`N.NiObjectDataFactory 无法创建<${_.params.app}/${_.params.name}>对象`);
                    } else throw new Error(`N.NiObjectDataFactory 无法找到<'${_.params.app}/${_.params.name}>对象`);
                    await super.open();
                }
                async close() {
                    const {
                        _,
                        __
                    } = pri(this);
                    if (__.obj) {
                        middler.setObjectByAppName(_.params.app, _.params.name, __.obj);
                        delete __.obj;
                    }
                    await super.close();
                }
                async invoke(cmd) {
                    const {
                        _,
                        __
                    } = pri(this);
                    if (_.transaction) {
                        __.cmds[__.cmds.length] = {
                            command: cmd.command,
                            params: cmd.params
                        };
                    } else
                        return await __.invoke(cmd.command, cmd.params);
                }
                async commit() {
                    const {
                        _,
                        __
                    } = pri(this);
                    if (_.transaction) {
                        //事务性处理
                        let data = [];
                        let cmds = __.cmds;
                        __.cmds = [];
                        await V.each(cmds, async v => {
                            data[data.length] = await __.invoke(v.command, v.params);
                        }, true);
                        return data;
                    } else
                        throw new Error('非事务条件下不可调用此方法');
                }
            }
        });
    }
    createDBConnection() {
        const {
            _,
            __
        } = pri(this);
        return new __.ObjectConnection();
    }
};
export const NiMemSQLDataFactory = class extends NiDataFactory {
    constructor(parser) {
        super();
        let that = this;
        const {
            _,
            __
        } = pri(that, {
            MemSQLConnection: class extends NiDataConnection {
                constructor() {
                    super();
                    const _this = this;
                    const {
                        _,
                        __
                    } = pri(this, {
                        cmds: [],
                        conn: null,
                        invoke: async(command, params) => {
                            const {
                                _,
                                __
                            } = pri(_this);
                            let queryList = that.parser.parse(command, params);
                            let data = [];
                            await V.each(queryList, async(v, call) => {
                                let cacheKey = _this.getKey(v);
                                switch (v.Method.toLowerCase().trim()) {
                                    case "select":
                                        data[data.length] = await V.callback(call => __.conn.get(cacheKey, call));
                                        break;
                                    case "insert":
                                    case "update":
                                        const datetime = V.getValue(V.toJsonString(v.DateTimeParam).length > 2 ? (() => {
                                            for (let k in v.DateTimeParam) return v.DateTimeParam[k];
                                        })() : params.DateTime, _.params.datetime);
                                        const values = {};
                                        for (let k in v.MethodParam) {
                                            let v2 = v.MethodParam[k];
                                            values[k] = v2.value ? v2.value : v2;
                                        }
                                        await V.callback(__.conn.set, __.conn, cacheKey, values, datetime);
                                        data[data.length] = ({
                                            value: 1
                                        });
                                        break;
                                    case "delete":
                                        await V.callback(__.conn.del, __.conn, cacheKey);
                                        data[data.length] = ({
                                            value: 1
                                        });
                                        break;
                                    case "touch":
                                        let dt = V.getValue(V.toJsonString(v.DateTimeParam).length > 2 ? (() => {
                                            for (let k in v.DateTimeParam) return v.DateTimeParam[k];
                                        })() : cmd.params.DateTime, _.params.datetime);
                                        await V.callback(__.conn.touch, __.conn, cacheKey, dt);
                                        data[data.length] = ({
                                            value: 1
                                        });
                                        break;
                                }
                                return false;
                            }, true);
                            return data;
                        }
                    });
                    _.params = {
                        connectionLimit: 10,
                        datetime: 1000
                    };
                }
                getKey(p) {
                    let cacheKey = p.Table;
                    if (V.toJsonString(p.IDs).length > 2) {
                        let sb = V.sb();
                        for (let k in p.IDs)
                            sb.append(p.IDs[k]).append('_');
                        cacheKey += ("K" + V.hash(sb.clear().trim('_')));
                        sb = null;
                    } else if (p.Params["cacheKey"])
                        cacheKey += ("K" + V.hash(p.Params["cacheKey"][0], true));
                    else
                        throw new Error("表未定义<主键>,或者传入键值中未找到cacheKey");
                    return cacheKey;
                }
                async invoke(cmd) {
                    const {
                        _,
                        __
                    } = pri(this);
                    if (_.transaction) {
                        __.cmds[__.cmds.length] = {
                            command: cmd.command,
                            params: cmd.params
                        };
                    } else
                        return await __.invoke(cmd.command, cmd.params);
                }
                async commit() {
                    const {
                        _,
                        __
                    } = pri(this);
                    if (_.transaction) {
                        //事务性处理
                        let data = [];
                        let cmds = __.cmds;
                        __.cmds = [];
                        await V.each(cmds, async v => {
                            data[data.length] = await __.invoke(v.command, v.params);
                        }, true);
                        return data;
                    } else
                        throw new Error('非事务条件下不可调用此方法');
                }
                async open() {
                    //https://www.npmjs.com/package/memcached#options
                    const {
                        _,
                        __
                    } = pri(this);
                    __.conn = new Mem(_.params.hosts, _.params);
                    await super.open();
                }
                async close() {
                    const {
                        _,
                        __
                    } = pri(this);
                    try {
                        __.conn.end();
                    } catch (e) {}
                    __.cmds = [];
                    __.conn = null;
                    await super.close();
                }
            }
        });
        _.parser = parser;
    }
    createDBConnection() {
        const {
            _,
            __
        } = pri(this);
        return new __.MemSQLConnection();
    };
    backDBConnection(conn) {
        conn.close();
    };
};
/**
 * https://www.npmjs.com/package/memcached#options
 */
export const NiMongoSQLDataFactory = class extends NiDataFactory {
    constructor(parser) {
        super();
        let that = this;
        const {
            _,
            __
        } = pri(that, {
            MongoSQLConnection: class extends NiDataConnection {
                constructor() {
                    super();
                    let _this = this;
                    const {
                        _,
                        __
                    } = pri(_this, {
                        cmds: [],
                        conn: null,
                        invoke: async(command, params) => {
                            const {
                                _,
                                __
                            } = pri(_this);
                            let queryList = _this.parse(command, params);
                            let data = [];
                            await V.each(queryList, async(v) => {
                                const func = (data, p) => {
                                    for (let k in data) {
                                        let v = data[k];
                                        if (typeof (v.value) != 'undefined' || typeof (v._id) != 'undefined') {
                                            p[k] = v.value;
                                        } else {
                                            p[k] = {};
                                            func(v, p.k);
                                        }
                                    }
                                };
                                let wheres = {};
                                func(v.WhereParam, wheres);

                                const values = {};
                                for (let k in v.MethodParam) {
                                    let v2 = v.MethodParam[k];
                                    values[k] = v2.value ? v2.value : v2;
                                }
                                switch (v.Method.toLowerCase().trim()) {
                                    case "select":
                                        data[data.length] = await V.callback(call => __.conn.collection(v.Table).find(wheres).toArray(call));
                                        break;
                                    case "insert":
                                        //应该是更新
                                        await V.callback(call => __.conn.collection(v.Table).insert(values, {
                                            safe: true
                                        }, call));
                                        data[data.length] = {
                                            value: 1
                                        };
                                        break;
                                    case "update":
                                        await V.callback(call => __.conn.collection(v.Table).update(wheres, {
                                            '$set': values
                                        }, {
                                            safe: true
                                        }, call));
                                        data[data.length] = {
                                            value: 1
                                        };
                                        break;
                                    case "delete":
                                        await V.callback(call => __.conn.collection(v.Table).remove(wheres, {
                                            safe: true
                                        }, call));
                                        data[data.length] = {
                                            value: 1
                                        };
                                        break;
                                }
                                return false;
                            }, true);
                            return data;
                        }
                    });
                    _.params = {
                        connectionLimit: 10
                    };
                }
                parse(sql, params) {
                    const {
                        _,
                        __
                    } = this;
                    const ret = that.parser.parse(sql, params);
                    const param = {};
                    const func = (data, p) => {
                        for (let k in data) {
                            let v = data[k];
                            if (v.split) {} else {
                                p[k] = {};
                                func(v, p.k)
                            };
                            switch (k.toLowerCase()) {
                                case 'or':
                                    const _data = [];
                                    p['$or'] = _data;
                                    for (let k2 in p[k]) {
                                        let v2 = p[k][k2];
                                        _data[_data.length] = ({
                                            k2: v2
                                        });
                                    }
                                    break;
                                case 'and':
                                    p = V.merge(p, v);
                                    break;
                                case 'in':
                                    //todo
                                    break;
                                case '<':
                                    for (let k2 in p[k]) {
                                        let v2 = p[k][k2];
                                        if (p[k2]) {
                                            if (p[k2].split) {} else p[k2]['$lt'] = v2;
                                        } else p[k2] = {
                                            "$lt": v2
                                        }
                                    }
                                    break;
                                case '<=':
                                    for (let k2 in p[k]) {
                                        let v2 = p[k][k2];
                                        if (p[k2]) {
                                            if (p[k2].split) {} else p[k2]['$lte'] = v2;
                                        } else p[k2] = {
                                            "$lte": v2
                                        }
                                    }
                                    break;
                                case '>':
                                    for (let k2 in p[k]) {
                                        let v2 = p[k][k2];
                                        if (p[k2]) {
                                            if (p[k2].split) {} else p[k2]['$gt'] = v2;
                                        } else p[k2] = {
                                            "$gt": v2
                                        }
                                    }
                                    break;
                                case '>=':
                                    for (let k2 in p[k]) {
                                        let v2 = p[k][k2];
                                        if (p[k2]) {
                                            if (p[k2].split) {} else p[k2]['$gte'] = v2;
                                        } else p[k2] = {
                                            "$gte": v2
                                        }
                                    }
                                    break;
                            }
                        }
                    };
                    func(ret.WhereParam, param);
                    return ret;
                }
                async invoke(cmd) {
                    const {
                        _,
                        __
                    } = pri(this);
                    if (_.transaction) {
                        __.cmds[__.cmds.length] = {
                            command: cmd.command,
                            params: com.params
                        };
                    } else
                        return await __.invoke(cmd.command, cmd.params);
                }
                async commit() {
                    const {
                        _,
                        __
                    } = pri(this);
                    if (_.transaction) {
                        //事务性处理
                        let data = [];
                        let cmds = __.cmds;
                        __.cmds = [];
                        await V.each(cmds, async v => {
                            data[data.length] = await __.invoke(v.command, v.params);
                        }, true);
                        return data;
                    } else
                        throw new Error('非事务条件下不可调用此方法');
                }
                async open() {
                    const {
                        _,
                        __
                    } = pri(this);
                    __.conn = await V.callback(Mon.MongoClient.connect, Mon.MongoClient, _.params.hosts);
                    await super.open();
                }
                async close() {
                    const {
                        _,
                        __
                    } = pri(this);
                    try {
                        __.conn.close();
                    } catch (e) {}
                    __.conn = null;
                    __.cmds = [];
                    await super.close();
                }
            }
        });
        _.parser = parser;
    }
    createDBConnection() {
        const {
            _,
            __
        } = pri(this);
        return new __.MongoSQLConnection();
    };
    backDBConnection(conn) {
        conn.close();
    };
};

/*redis nosql 支持
 * 目前事务未支持
 */
export const NiRedisSqlDataFactory = class extends NiDataFactory {
    constructor(parser) {
        super();
        let that = this;
        const {
            _,
            __
        } = pri(that, {
            RedisSqlConnection: class extends NiDataConnection {
                constructor() {
                    super();
                    const _this = this;
                    const {
                        _,
                        __
                    } = pri(this, {
                        cmds: [],
                        host: "",
                        port: "",
                        password: "",
                        method: "",
                        timeout: 60000,
                        conn: null,

                        invoke: async(command, params) => {
                            const {
                                _,
                                __
                            } = pri(_this);
                            let queryList = that.parser.parse(command, params);
                            let data = [];
                            var trans = false;
                            var transprefunc = [];
                            var transfunc = [];
                            await V.each(queryList, async(v, call) => {
                                switch (v.Method.toLowerCase().trim()) {
                                    case "transaction":
                                        trans = true;
                                        break;
                                    case "select":
                                        var key = V.hash2(V.toJsonString(v.IDs)) + "";
                                        var majorkey = v.Table + key;
                                        if (trans) {
                                            transfunc[transfunc.length] = __.conn.get(majorkey, call);
                                        } else {

                                            var res = await V.callback(call => __.conn.get(majorkey, call));

                                            try {

                                                var jsdat = V.json(res);
                                                data[data.length] = V.json(res);

                                            } catch (e) {
                                                for (let k in v.IDs) {
                                                    const ret2 = {};
                                                    ret2[k] = res;
                                                    data[data.length] = ret2;
                                                    break;
                                                }
                                            }
                                        }
                                        break;
                                    case "insert":
                                    case "update":
                                        const datetime = V.getValue(V.toJsonString(v.DateTimeParam).length > 2 ? (() => {
                                            for (let k in v.DateTimeParam) return v.DateTimeParam[k];
                                        })() : params.DateTime, _.params.datetime);
                                        const values = {};
                                        for (let k in v.MethodParam) {
                                            let v2 = v.MethodParam[k];
                                            values[k] = v2.value ? v2.value : v2;
                                        }

                                        var key = V.hash2(V.toJsonString(v.IDs)) + "";
                                        var value = V.toJsonString(v.MethodParam);
                                        var majorkey = v.Table + key;
                                        var func;
                                        if (datetime != '-1') {
                                            func = call => __.conn.set(majorkey, value, "px", datetime, call);
                                        } else {
                                            func = call => __.conn.set(majorkey, value, call);
                                        }

                                        if (trans) {
                                            transprefunc[transprefunc.length] = call => __.conn.watch(majorkey, call)
                                            transfunc[transfunc.length] = func;
                                        } else {
                                            var res = await V.callback(func);
                                            data[data.length] = ({
                                                value: 1
                                            });
                                        }
                                        break;
                                    case "delete":
                                        var key = V.hash2(V.toJsonString(v.IDs)) + "";
                                        var majorkey = v.Table;

                                        if (trans) {
                                            transprefunc[transprefunc.length] = call => __.conn.watch(majorkey);
                                            transfunc[transfunc.length] = call => __.conn.hdel(majorkey, key);
                                        } else {
                                            await V.callback(call => __.conn.hdel(majorkey, key, call));
                                            data[data.length] = ({
                                                value: 1
                                            });
                                        }

                                        break;
                                }
                                return false;
                            }, true);

                            if (trans) {
                                await V.each(transprefunc, async(v, call) => {

                                    await V.callback(v);
                                }, true);
                                await __.conn.multi({
                                    pipeline: false
                                });
                                await V.each(transfunc, async(v, call) => {
                                    await V.callback(v);
                                    data[data.length] = ({
                                        value: 1
                                    });
                                }, true);
                                await V.callback(call => __.conn.exec(call));
                            }

                            return data;
                        }
                    });
                    _.params = {
                        connectionLimit: 10,
                        datetime: -1
                    };
                }
                async invoke(cmd) {
                    const {
                        _,
                        __
                    } = pri(this);
                    if (_.transaction) {
                        __.cmds[__.cmds.length] = {
                            command: cmd.command,
                            params: cmd.params
                        };
                    } else
                        return await __.invoke(cmd.command, cmd.params);
                }
                async commit() {
                    const {
                        _,
                        __
                    } = pri(this);
                    if (_.transaction) {
                        //事务性处理
                        let data = [];
                        let cmds = __.cmds;
                        __.cmds = [];
                        await V.each(cmds, async v => {
                            data[data.length] = await __.invoke(v.command, v.params);
                        }, true);
                        return data;
                    } else
                        throw new Error('非事务条件下不可调用此方法');
                }
                async open() {
                    //https://www.npmjs.com/package/memcached#options
                    const {
                        _,
                        __
                    } = pri(this);

                    __.host = _.params.host || '192.168.0.1';
                    __.port = _.params.port || 6379;
                    __.password = _.params.password || '';
                    __.timeout = _.timeout || 60000;

                    let redisargs = {
                        port: __.port, // Redis port 
                        host: __.host, // Redis host 
                        family: 4, // 4 (IPv4) or 6 (IPv6) 
                        password: __.password,
                        db: 0
                    }
                    __.conn = new Redis(redisargs);
                    await super.open();
                }
                async close() {
                    const {
                        _,
                        __
                    } = pri(this);
                    try {
                        __.conn.end();
                    } catch (e) {}
                    __.cmds = [];
                    __.conn = null;
                    await super.close();
                }
            }
        });
        _.parser = parser;
    }
    createDBConnection() {
        const {
            _,
            __
        } = pri(this);
        return new __.RedisSqlConnection();
    };
    backDBConnection(conn) {
        conn.close();
    };
};

/*redis nosql 支持
 * 由于redis的watch机制，redis可支持多条sql事务，但不支持外部事务调用
 */
export const NiRedisHashSqlDataFactory = class extends NiDataFactory {
    constructor(parser) {
        super();
        let that = this;
        const {
            _,
            __
        } = pri(that, {
            RedisHashSqlConnection: class extends NiDataConnection {
                constructor() {
                    super();
                    const _this = this;
                    const {
                        _,
                        __
                    } = pri(this, {
                        cmds: [],
                        host: "",
                        port: "",
                        password: "",
                        method: "",
                        timeout: 60000,
                        conn: null,
                        invoke: async(command, params) => {
                            const {
                                _,
                                __
                            } = pri(_this);
                            let queryList = that.parser.parse(command, params);
                            let data = [];
                            await V.each(queryList, async(v, call) => {
                                switch (v.Method.toLowerCase().trim()) {
                                    case "select":
                                        var key = V.hash2(V.toJsonString(v.WhereParam)) + "";
                                        var majorkey = v.Table;

                                        var res = await V.callback(call => __.conn.hmget(majorkey, key, call));
                                        try {
                                            data[data.length] = V.json(res);
                                        } catch (e) {
                                            for (let k in v.IDs) {
                                                const ret2 = {};
                                                ret2[k] = res;
                                                data[data.length] = ret2;
                                                break;
                                            }
                                        }
                                        break;
                                    case "insert":
                                    case "update":
                                        var key = V.hash2(V.toJsonString(v.IDs)) + "";
                                        var value = V.toJsonString(v.MethodParam);
                                        var majorkey = v.Table;

                                        var jsonvalue = {};
                                        jsonvalue[key] = value;
                                        // console.log(jsonvalue);
                                        await V.callback(call => __.conn.hmset(majorkey, jsonvalue, call));

                                        data[data.length] = ({
                                            value: 1
                                        });
                                        break;
                                    case "delete":
                                        var key = V.hash2(V.toJsonString(v.IDs)) + "";
                                        var majorkey = v.Table;

                                        await V.callback(call => __.conn.hdel(majorkey, key, call));
                                        data[data.length] = ({
                                            value: 1
                                        });
                                        break;
                                }
                                return false;
                            }, true);
                            return data;
                        }
                    });
                    _.params = {
                        connectionLimit: 10,
                        datetime: 1000
                    };
                }
                async invoke(cmd) {
                    const {
                        _,
                        __
                    } = pri(this);
                    if (_.transaction) {
                        __.cmds[__.cmds.length] = {
                            command: cmd.command,
                            params: cmd.params
                        };
                    } else
                        return await __.invoke(cmd.command, cmd.params);
                }
                async commit() {
                    const {
                        _,
                        __
                    } = pri(this);
                    if (_.transaction) {
                        //事务性处理
                        let data = [];
                        let cmds = __.cmds;
                        __.cmds = [];
                        await V.each(cmds, async v => {
                            data[data.length] = await __.invoke(v.command, v.params);
                        }, true);
                        return data;
                    } else
                        throw new Error('非事务条件下不可调用此方法');
                }
                async open() {
                    //https://www.npmjs.com/package/memcached#options
                    const {
                        _,
                        __
                    } = pri(this);

                    __.host = _.params.host || '192.168.0.1';
                    __.port = _.params.port || 6379;
                    __.password = _.params.password || '';
                    __.timeout = _.timeout || 60000;

                    let redisargs = {
                        port: __.port, // Redis port 
                        host: __.host, // Redis host 
                        family: 4, // 4 (IPv4) or 6 (IPv6) 
                        password: __.password,
                        db: 0
                    }
                    __.conn = new Redis(redisargs);
                    await super.open();
                }
                async close() {
                    const {
                        _,
                        __
                    } = pri(this);
                    try {
                        __.conn.end();
                    } catch (e) {}
                    __.cmds = [];
                    __.conn = null;
                    await super.close();
                }
            }
        });
        _.parser = parser;
    }
    createDBConnection() {
        const {
            _,
            __
        } = pri(this);
        return new __.RedisHashSqlConnection();
    };
    backDBConnection(conn) {
        conn.close();
    };
};
//todo  wcf

/**
 * NiUrlDataFactory
 * 自动调用远程URL
 */
export const NiUrlDataFactory = class extends NiDataFactory {
    constructor() {
        super();
        const that = this;
        that.regex = new RegExp('^((http|https):\\/\\/[\\w\\-_]+(\.[\\w\\-_]+)+([\\w\\-\\.,@?^=%&amp;:/~\\+#]*[\\w\\-\\@?^=%&amp;/~\+#])?)$', 'i');
        const {
            _,
            __
        } = pri(that, {
            UrlConnection: class extends NiDataConnection {
                constructor() {
                    super();
                    const thats = this;
                    const {
                        _,
                        __
                    } = pri(this, {
                        cmds: [],
                        host: "",
                        port: "",
                        method: "",
                        timeout: 60000,
                        invoke: async(command, params) => {
                            const {
                                _,
                                __
                            } = pri(thats);
                            let args = (params.args ? params.args.value : params);
                            const func = (function () {
                                for (let i in args) {
                                    if (args[i].value) args[i] = args[i].value;
                                }
                                switch ((params.method.value || __.method).toLowerCase()) {
                                    case 'get':
                                    default:
                                        args = Q.stringify(args);
                                        return N.get;
                                    case 'post':
                                        args = Q.stringify(args);
                                        return N.post;
                                    case 'postJson':
                                        return N.postJson;
                                }
                            })(); //立即执行函数获取返回值
                            let data = [];
                            await V.each(command.split(';'), async v => {
                                if (v.indexOf(':') < 0 && v.indexOf('//') < 0)
                                    v = "http://" + __.host + (V.isValid(__.port) && (__.port + "") != '80' ? ":" + __.port : "") + v;
                                if (that.regex.test(v)) {
                                    data[data.length] = [await func(v, args)];
                                } else
                                    throw new Error(`错误的路径${v}`);
                            }, true);
                            return data;
                        }
                    });
                }
                async open() {
                    const {
                        _,
                        __
                    } = pri(this);
                    __.host = _.params.host || null;
                    __.port = _.params.port || 80;
                    __.method = _.params.method || 'POST';
                    __.timeout = __.timeout || 60000;
                    await super.open();
                }
                async close() {
                    await super.close();
                }
                async invoke(cmd) {
                    const {
                        _,
                        __
                    } = pri(this);
                    if (_.transaction) {
                        __.cmds[__.cmds.length] = {
                            command: cmd.command,
                            params: cmd.params
                        };
                    } else
                        return await __.invoke(cmd.command, cmd.params);
                }
                async commit() {
                    const {
                        _,
                        __
                    } = pri(this);
                    if (_.transaction) {
                        //事务性处理
                        let data = [];
                        let cmds = __.cmds;
                        __.cmds = [];
                        await V.each(cmds, async v => {
                            data[data.length] = await __.invoke(v.command, v.params);
                        }, true);
                        return data;
                    } else
                        throw new Error('非事务条件下不可调用此方法');
                }
            }
        });
    }
    createDBConnection() {
        const {
            _,
            __
        } = pri(this);
        return new __.UrlConnection();
    }
};

/**
 * NiSoapDataFactory
 * soap数据源支持
 */
export const NiSoapDataFactory = class extends NiDataFactory {
    constructor() {
        super();
        const that = this;
        const {
            _,
            __
        } = pri(that, {
            SoapConnection: class extends NiDataConnection {
                constructor() {
                    super();
                    const thats = this;
                    const {
                        _,
                        __
                    } = pri(this, {
                        cmds: [],
                        host: "",
                        port: "",
                        method: "",
                        // control: "",
                        timeout: 60000,
                        invoke: async(command, params) => {

                            const {
                                _,
                                __
                            } = pri(thats);

                            const data = [];
                            var wcfurl;
                            var wcfcommand;
                            var wcfmethod;
                            var tmp = (__.host + (__.port ? ":" + __.port : "") + command);

                            var index = tmp.toLowerCase().indexOf("?singlewsdl/");
                            if (index < 0) {
                                throw new Error('url or command error');
                            }

                            wcfurl = tmp.substring(0, index + 11);
                            wcfmethod = tmp.substring(index + 12);

                            var soap = require('soap');

                            // var args = params["args"] ? params["args"].value : [];
                            // console.log(params);
                            var wcfargs = {};
                            let args = (params.args ? params.args.value : params);
                            for (let i in args) {
                                if (args[i].value) wcfargs[i] = args[i].value;
                            }
                            // console.log(wcfargs);
                            var start = function (url, method, args, callback) {

                                try {
                                    S.createClient(url, function (err, client) {

                                        if (err) {
                                            throw new Error(err);
                                        } else {

                                            client[method](args, function (err, result) {
                                                if (err) {
                                                    console.log("method err" + err.message);
                                                    throw new Error(err);
                                                } else {
                                                    // console.log(result);
                                                    let realresult = result[method + 'Result'];

                                                    data.push(realresult);
                                                }
                                                callback();

                                            });
                                        }
                                    });
                                } catch (error) {
                                    console.log("start err" + err.message);
                                }
                            }


                            await V.callback(
                                call => {
                                    start(wcfurl, wcfmethod, wcfargs, t => {
                                        null,
                                        call()
                                    })
                                }
                            );

                            return data;
                        }
                    });
                }
                async open() {
                    const {
                        _,
                        __
                    } = pri(this);

                    __.host = _.params.host || null;
                    __.port = _.params.port || 80;
                    // __.control = _.params.control || '';
                    __.method = _.params.method || 'get';
                    __.timeout = __.timeout || 60000;
                    await super.open();
                }
                async close() {
                    await super.close();
                }
                async invoke(cmd) {
                    const {
                        _,
                        __
                    } = pri(this);
                    if (_.transaction) {
                        __.cmds[__.cmds.length] = {

                            command: cmd.command,
                            params: cmd.params
                        };
                    } else
                        return await __.invoke(cmd.command, cmd.params);
                }
                async commit() {
                    const {
                        _,
                        __
                    } = pri(this);
                    if (_.transaction) {
                        //事务性处理
                        let data = []
                        await V.each(__.cmds, async v => {
                            data[data.length] = await __.invoke(v.command, v.params);
                        }, true);
                        __.cmds = [];
                        return data;
                    } else
                        throw new Error('非事务条件下不可调用此方法');
                }
            }
        });
    }
    createDBConnection() {
        const {
            _,
            __
        } = pri(this);
        return new __.SoapConnection();
    }
};

/**
 * NiMailDataFactory
 * 自动调用Mail服务器发送邮件
 * https://www.npmjs.com/package/emailjs
 * {
            text: '测试内容2', // text of the email 
            from: '26342049@qq.com', // sender of the format (address or name <address> or "name" <address>)
            to: 'baibing0004@sohu.com', // recipients (same format as above), multiple recipients are separated by a comma
            cc: '', // carbon copied recipients (same format as above)
            bcc: '', // blind carbon copied recipients (same format as above)
            subject: '测试邮件', // string subject of the email
            attachment: [
                    { data: "<html>i <i>测试啊测试</i> this works!</html>", alternative: true },
                    { path: "/Users/&&&/Downloads/福岛核辐射.jpg", type: M2.get("福岛核辐射2.jpg"), name: "福岛核辐射2.jpg" }
                ]
                // one attachment or array of attachments
        }
 */
export const NiMailDataFactory = class extends NiDataFactory {
    constructor() {
        super();
        const that = this;
        const {
            _,
            __
        } = pri(that, {
            MailConnection: class extends NiDataConnection {
                constructor() {
                    super();
                    const thats = this;
                    const {
                        _,
                        __
                    } = pri(this, {
                        cmds: [],
                        invoke: async(command, params) => {
                            const {
                                _,
                                __
                            } = pri(thats);
                            if (!__.conn) throw new Error('请先连接Mail服务器');
                            let args = (params.args ? params.args.value : params);
                            const func = (function () {
                                for (let i in args) {
                                    if (args[i].value) args[i] = args[i].value;
                                }
                            })(); //立即执行函数获取返回值
                            let data = [];
                            try {
                                await V.callback(__.conn.send, __.conn, args)
                            } finally {
                                data[data.length] = {
                                    success: true
                                }
                            }
                            return data;
                        }
                    });
                }
                async open() {
                    const {
                        _,
                        __
                    } = pri(this);
                    //user:	"username",   password:"password",  host:	"smtp.your-email.com",
                    __.conn = Mail.server.connect(V.merge({
                        ssl: true
                    }, _.params));
                    await super.open();
                }
                async close() {
                    __.conn = null;
                    await super.close();
                }
                async invoke(cmd) {
                    const {
                        _,
                        __
                    } = pri(this);
                    if (_.transaction) {
                        __.cmds[__.cmds.length] = {
                            command: cmd.command,
                            params: cmd.params
                        };
                    } else
                        return await __.invoke(cmd.command, cmd.params);
                }
                async commit() {
                    const {
                        _,
                        __
                    } = pri(this);
                    if (_.transaction) {
                        //事务性处理
                        let data = [];
                        let cmds = __.cmds;
                        __.cmds = [];
                        await V.each(cmds, async v => {
                            data[data.length] = await __.invoke(v.command, v.params);
                        }, true);
                        return data;
                    } else
                        throw new Error('非事务条件下不可调用此方法');
                }
            }
        });
    }
    createDBConnection() {
        const {
            _,
            __
        } = pri(this);
        return new __.MailConnection();
    }
};

/**
 * es 池连接方式工厂
 */
export const NiElasticSearchDataFactory = class extends NiDataFactory {
    constructor() {
        super();
        const that = this;
        that.idic = {};
        const {
            _,
            __
        } = pri(that, {
            ElasticSearchConnection: class extends NiDataConnection {
                constructor() {
                    super();
                    const that = this;
                    const {
                        _,
                        __
                    } = pri(this, {
                        cmds: [],
                        conn: null,
                        invoke: async(command, params) => {
                            try {
                                const {
                                    _,
                                    __
                                } = pri(that);
                                let args = (params.args ? params.args.value : params);
                                const func = (function () {
                                    for (let i in args) {
                                        if (args[i].value) args[i] = args[i].value;
                                    }
                                })(); //立即执行函数获取返回值

                                const result = await V.callback(__.conn.create, __.conn, V.merge({
                                        index: '',
                                        type: 'logs',
                                        id: '',
                                        body: {
                                            title: '',
                                            message: ''
                                        }
                                    },
                                    args));

                                let data = [];
                                data[data.length] = [{
                                    success: true
                                }];

                                return data;
                            } catch (e) {
                                console.log(e.message);
                                throw e;
                            }
                        }
                    });
                    _.params = {
                        host: ''
                    };
                }
                async invoke(cmd) {
                    //需要处理单条与多条s
                    const {
                        _,
                        __
                    } = pri(this);
                    if (_.transaction) {
                        __.cmds[__.cmds.length] = {
                            command: cmd.command,
                            params: cmd.params
                        };
                    } else
                        return await __.invoke(cmd.command, cmd.params);
                }
                async commit() {
                    const {
                        _,
                        __
                    } = pri(this);
                    if (_.transaction) {
                        //事务性处理
                        try {
                            let data = [];
                            let cmds = __.cmds;
                            __.cmds = [];
                            await V.each(cmds, async v => {
                                //console.log(v.cmd.params);
                                data[data.length] = await __.invoke(v.command, v.params);
                                return false;
                            }, true);
                            return data;
                        } catch (e) {
                            throw e;
                        }
                    } else
                        throw new Error('非事务条件下不可调用此方法');
                }
                async open() {
                    const {
                        _,
                        __
                    } = pri(this);
                    __.conn = new es.Client(V.merge({
                        log: 'trace'
                    }, _.params));
                    await super.open();
                }
                async close() {
                    const {
                        _,
                        __
                    } = pri(this);
                    try {
                        if (__.conn && __.conn.release)
                            __.conn.release();
                        else if (__.conn && __.conn.end)
                            __.conn.end();
                        else if (__.conn && __.conn.dispose)
                            __.conn.dispose();
                    } catch (e) {}
                    __.cmds = [];
                    __.conn = null;
                    await super.close();
                }
            }
        });
    }
    createDBConnection() {
        const {
            _,
            __
        } = pri(this);
        return new __.ElasticSearchConnection();
    }
    dispose() {
        const {
            _,
            __
        } = pri(this);
        V.tryC(() => {
            __.conn.dispose();
        });
    }
};
/**
 * 内存对象缓存工厂
 */
export class MemoryCacheFactory extends NiDataFactory {
    constructor(parser, maxSize) {
        super()
        let fac_context = this
        const {
            _,
            __
        } = pris(fac_context, {
            MemCacheConnection: class extends NiDataConnection {
                constructor() {
                    super()
                    let con_context = this
                    const {
                        __
                    } = pris(con_context, {
                        cmds: [],
                        conn: null,
                        memCache: new MemoryCacheStore(fac_context.maxSize),
                        invoke: async(command, params) => {
                            const {
                                __
                            } = pris(con_context)
                            let queryList = fac_context.parser.parse(command, parmas)
                            let data = []
                            await commonTool.each(queryList, async(v, call) => {
                                let cacheKey = __.getKey(v)
                                switch (v.Method.toLowerCase().trim()) {
                                    case 'select':
                                        data[data.length] = __.memCache.get(cacheKey)
                                        break;
                                    case 'insert':
                                    case 'update':
                                        data[data.length] = __.memCache.put(cacheKey)
                                        break;
                                    case 'delete':
                                        data[data.length] = __.memCache.delete(cacheKey)
                                        break;
                                }
                                return false
                            }, true)
                        },
                        getKey: v => {
                            let cacheKey = v.Table
                            if (v.Params['cacheKey']) {
                                cacheKey = (commonTool.hash(v.Params['cacheKey'], true))
                            } else {
                                throw new Error('表未定义主键 或者传入的值中未找到cacheKey')
                            }
                            return cacheKey
                        }
                    })
                }
                async invoke(cmd) {
                    const {
                        _,
                        __
                    } = pri(this)
                    if (_.transaction) {
                        __.cmd[__.cmd.length] = {
                            command: cmd.command,
                            params: cmd.params,
                        }
                    } else {
                        return await __.invoke(cmd.command, cmd.params)
                    }
                }
                async close() {
                    const {
                        __
                    } = pri(this)
                    __.cmds = []
                    await super.close()
                }
            }
        })
        _.parser = parser, _.maxSize = maxSize
    }
    createDBConnection() {
        const {
            __
        } = pri(this)
        return new __.MemCacheConnection()
    }
    backDBConnection(conn) {
        conn.close()
    }
}
/**
 * Memory cache 的具体实现 缓存过期策略 采用LRU算法
 * 默认最大可以缓存1万条数
 * 只可以做一些Master数据的缓存 如果想保存其他的数据 例如Session 必须使用第三方的缓存 例如: Redis
 */
export class MemoryCacheStore {
    constructor(maxSize = 10000) {

        const {
            _,
            __
        } = pri(this, {
            cache: {},
            size: 0,
            maxSize,
            expire() {
                //请注意 __ == this;
                let key, earliest = Number.MAX_VALUE;
                V.forC(__.cache, (k, v) => {
                    if (v.time < earliest) {
                        earliest = v.time
                        key = k
                    }
                }, true)
                if (key) {
                    let data = __.cache[key]
                    clearTimeout(data.timeout)
                    delete __.cache[key]
                    __.size--
                }
            }
        })
    }
    /**
     * 按照键值对 保存数据
     * 数据有过期时间 默认为1天 过期后 数据自动删除
     * 达到最大容量后 按照LRU原则 删除最后访问时间最晚的数据
     * @param {*} key 唯一主键
     * @param {*} value 保存的数据
     * @param {*} expire 过期时间 默认为1天
     */
    put(key, value, expire = 1440000) {
        if (typeof expire !== 'number' || isNaN(expire) || expire <= 0) {
            throw new Error('请输入正确的过期时间')
        }
        const {
            _,
            __
        } = pri(this)
        let oldRecord = __.cache[key]
        if (oldRecord) {
            clearTimeout(oldRecord.timeout)
        } else {
            if (__.size >= __.maxSize) {
                __.expire()
            }
            __.size++
        }
        let now = Date.now(),
            data = {
                value: value,
                expire: now + expire,
                time: now
            }
        data.timeout = setTimeout(function () {
            delete __.cache[key]
            __.size--
        }, expire)
        __.cache[key] = data
        return data.value
    }
    /**
     * 从缓存里按照给定的Key值读取数据
     * 读取不到的情况 返回undefined
     * @param {*} key 唯一的Key值
     */
    get(key) {
        const {
            __
        } = pri(this)
        let data = __.cache[key]
        if (typeof data == 'undefined') {
            return undefined
        }
        return data.value
    }
    /**
     * 删除缓存中指定key对应的数据
     * @param {*} key 唯一的主键
     */
    delete(key) {
        const {
            __
        } = pri(this)
        let oldRecord = __.cache[key]
        if (oldRecord) {
            clearTimeout(oldRecord.timeout)
            delete __.cache[key]
            return oldRecord
        }
        return undefined
    }
    /**
     * 清除缓存中的数据
     * 同时清除掉所有的expire timer
     */
    clear() {
        const {
            __
        } = pri(this)
        V.forC(__.cache, (k, v) => {
            clearTimeout(v.timemout)
        }, true)
        __.size = 0
        __.cache = Object.create(null)
    }
    /**
     * 返回缓存中保存的数据条数
     */
    get size() {
        const {
            __
        } = pri(this)
        return __.size
    }
}
export default {
    NiDataConfig,
    NiDataConfigConvert,
    NiTemplate,
    NiTemplateManager,
    NiDataResult,
    NiDataResource,
    NiInstanceDataResource,
    NiStaticDataResource,
    NiPoolDataResource,
    NiDataFactory,
    NiDataConnection,
    NiDataCommand,
    NiTemplateDecorator,
    NiMultiTemplateDecorator,
    NiMySQLDataFactory,
    NiMsSQLDataFactory,
    NiObjectDataFactory,
    NiUrlDataFactory,
    NiMailDataFactory,
    NiRedisSqlDataFactory,
    NiRedisHashSqlDataFactory,
    NiSoapDataFactory
};
const pri = V.pris();